
jQuery(function($){

	w2_is_clicked_btn = 'w2_btn_view';
	initEditor = true;
	initFormEditor();
	
	function initFormEditor() {
		
		target = 'form_editor/form_editor.php?action=displayeditor';
		$('.container_editor').load(target, function(response, status, xhr){
		  if (status == "error") {
			alert("AJAX CALL ERROR\n The script PHP: "+target+" is not found - "+xhr.status + " " + xhr.statusText+"\n.");
		
		  }
		  else {
			  initEffect();
			  initTemplatesHtml();
			  initFormEditor2();
			  initTemplatesCss();
			  initTemplatesUiCss();
			  initColorPicker();
			  
			  //$('#load_css_template').attr("checked","checked");
			  var target = $('#template_fields').val();
			  loadTemplatesHtml(target);
			  $('.'+w2_is_clicked_btn+'').trigger('click');
			  
			  
		  } 
		});
        
	}
	
	function initColorPicker() {
		$('#colorpicker').farbtastic('#color');
	}

	
	function initEffect() {
		$('.w2_contact_form .btn_to_slide').unbind('click');
		$('.w2_contact_form .btn_to_slide').bind('click', function() {
			var target = $(this).attr('target');
			$('.w2_contact_form .'+target+'').slideToggle(1000);
		});
		
		$('.w2_contact_form .btn_infos').unbind('click');
		$('.w2_contact_form .btn_infos').bind('click', function() {
			
			$('.w2_infos').css('display', 'none');
			$(this).parent().children('.w2_infos').fadeIn(300);
		});
		
		$('.w2_contact_form .btn_close_infos').unbind('click');
		$('.w2_contact_form .btn_close_infos').bind('click', function() {
			
			$(this).parent().fadeOut(300, function() {
				$(this).css('display', 'none');
			});
		});
		
		$('.w2_contact_form .w2_btn_options').unbind('click');
		$('.w2_contact_form .w2_btn_options').bind('click', function() {
			$('.w2_btn_view').trigger('click');
		});
		
		$('.w2_contact_form .brn_submit').unbind('click');
		$('.w2_contact_form .brn_submit').bind('click', function() {
			var action = $(this).attr('action'); 
			$('#action_editor').val(action);
			
			if(action == 'createcsssourcefile' && $('#w2_form_css').val() == '')
			  alert('Your custom CSS is empty');
			else
			  $('#form_editor').submit();
		});
		
		$('#dialog_info').load("form_editor/includes/html_componoents_list.html", function(response, status, xhr){
		  if (status == "error") {
			alert("AJAX CALL ERROR\n "+xhr.status + " " + xhr.statusText+"\n.");
		  }
		  else {
				$( ".container_html_comp_list" ).dialog({
					autoOpen: false,
					width: "800px",
					resizable: true,
					show: "fade",
                    hide: "fade"
					
				});
			
				$( ".open_dialog_info" ).click(function() {
					$( ".container_html_comp_list" ).dialog( "open" );
					$('.container_html_comp_list').css('height', '600px');
					return false;
				});
		  } 
		});	
	
	}

	function stringToBoolean(string){
		switch(string.toLowerCase()){
			case "true": case "yes": case "1": return true;
			case "false": case "no": case "0": case null: return false;
			default: return Boolean(string);
		}
	}


	
	
	function initW2ContactForm() {
		
		var opt_no_spam_control = stringToBoolean($('select.opt_no_spam_control').val());
		var opt_no_spam_control_type = parseInt($('select.opt_no_spam_control_type').val());
		var opt_submit_alert_type = $('select.opt_submit_alert_type').val();
		var opt_att_alert_type = $('select.opt_att_alert_type').val();
		
		var opt_custom_file_input = stringToBoolean($('select.opt_custom_file_input').val());
		var opt_show_btn_send = stringToBoolean($('select.opt_show_btn_send').val());
		var opt_attachment_file = stringToBoolean($('select.opt_attachment_file').val());
		var opt_max_attachment_files = parseInt($('select.opt_max_attachment_files').val());
		var opt_reset_form = stringToBoolean($('select.opt_reset_form').val());
		
		var opt_ayah = stringToBoolean($('select.opt_ayah').val());
		var opt_reload_captcha = stringToBoolean($('select.opt_reload_captcha').val());
		var opt_recaptcha_lang = $('select.opt_recaptcha_lang').val();
		var opt_recaptcha_theme = $('select.opt_recaptcha_theme').val();

		//for production
		var opt_re_captcha = $('input.opt_re_captcha').val();
		if(opt_re_captcha != '')
		 opt_re_captcha = opt_re_captcha;
		else
		 opt_re_captcha = null;
        
		//Initialisation of the form
		$('#container_w2ContactForm').w2ContactForm({
			noSpamControl: opt_no_spam_control,  //Specifie if No Spam Control is activate (true / false)
			noSpamControlType: opt_no_spam_control_type,  //Spcifie the Type of No Spam Control (1 / 2)
			resetForm: opt_reset_form, //Spcifie if reset form after submit (true / false)
			attachmentFile: opt_attachment_file,  //Specifie if attachment file is activate (true / false)
			maxAttachments: opt_max_attachment_files, //Specifie the maximum number of attachments files
			showBtnSend: opt_show_btn_send, //Specifie if the btn send is visible when loading form when No Spam Control is activate (true / false)
			customFileInput: opt_custom_file_input, //Specifie if file input is custom skin (true / false)
			submitAlertType: opt_submit_alert_type, //Specifie the type of alert displaying for submit (dialog / slide)
			maxAttAlertType: opt_att_alert_type, //Specifie the type of alert displaying for maximum attachments (dialog / slide)
			reCaptchaPublicKey: opt_re_captcha, //Specifie your reCaptcha PublicKey
			reCaptchaId: 'recaptcha_id', //Specifie an unqiue ID for HTML element where reCaptcha will be integrated (just specifie the ID do not create the element in the form)
			reCaptchaTheme: opt_recaptcha_theme, //Specifie the reCaptcha theme you want to use
			reCaptchaLang: opt_recaptcha_lang, //Specifie the reCaptcha Lang you want to use
			reloadCaptcha: opt_reload_captcha, //Specifie if captcha is reloaded after submit (true / false)
			ayah: opt_ayah //Specifie if AYAH is activate	
		});
	
	}
	
	function initTemplatesHtml() {
		$('#template_fields').bind('change', function() {
			 if($(this).val() != 'default') {
				var target = $(this).val();
				loadTemplatesHtml(target);
			 }
		});
	}
	
	function loadTemplatesHtml(target) {
		$('#w2_form_source').load(target, function(response, status, xhr){
		  if (status == "error") {
			alert("AJAX CALL ERROR\n The script PHP: "+target+" is not found - "+xhr.status + " " + xhr.statusText+"\n.");
		
		  }
		  else {
			  $('#w2_form_source').val($('#w2_form_source').text());
			  $('.'+w2_is_clicked_btn+'').trigger('click');
		  }
		});
	}

	function initTemplatesUiCss() {
		//wp_w2_contact_form_ui
		$('#css_ui_theme').bind('change', function() {
			 if($(this).val() != 'default') {
				loadUiCss($(this));
			 }
		});
	}
	
	function loadUiCss($this) {
		var cssLink = 'w2_acf/css/ui/'+$this.val()+'/jquery-ui-1.8.24.custom.css';
	    $('#w2_ui_theme').attr('href', cssLink);
    }
	
	customedCssImgDir = '';
	function initTemplatesCss() {
		//wp_w2_contact_form_ui
		$('#css_theme').bind('change', function() {
			 if($(this).val() != 'default') {
				
			    var cssLink1 = 'w2_acf/css/w2_contact_form/'+$(this).val()+'/custom.css';
				if($('#custom_template:checked').val() != 1)
				  $('#w2_css_theme').attr('href', cssLink1);
				
				$('#css_ui_theme').val($(this).val());
				var cssLink2 = 'w2_acf/css/ui/'+$(this).val()+'/jquery-ui-1.8.24.custom.css';
				$('#w2_ui_theme').attr('href', cssLink2);
				
				if($('#load_css_template:checked').val() == 1) {
					loadCss(cssLink1);
				}
			 }
		});
		
		$('#load_css_template').bind('change', function() {
			    if($('#load_css_template:checked').val() == 1) {
				    var cssLink1 = 'w2_acf/css/w2_contact_form/'+$('#css_theme').val()+'/custom.css';
				    $('#w2_css_theme').attr('href', cssLink1);
					loadCss(cssLink1);
					//refreshPreview();
				}
		});
		
		$('#custom_template').bind('change', function() {
			    if($('#custom_template:checked').val() == 1) {
				    
					if($('#w2_form_css').val() == '') {
					  var cssLink1 = 'w2_acf/css/w2_contact_form/'+$('#css_theme').val()+'/custom.css';
					  loadCss(cssLink1); 
					}
					else {
					  var cssLink1 = 'w2_acf/css/w2_contact_form/none/custom.css';
				      $('#w2_css_theme').attr('href', cssLink1);
					  $('.w2_btn_view').trigger('click');
					}
				}
				else {
					var cssLink1 = 'w2_acf/css/w2_contact_form/'+$('#css_theme').val()+'/custom.css';
				    $('#w2_css_theme').attr('href', cssLink1);
					//loadCss(cssLink1);
					displayContentPreview();
		        }
		});
		
		
	}
	
	function loadCss(cssLink1) {
		$('#w2_form_css').load(cssLink1, function(response, status, xhr){
		  if (status == "error") {
			alert("AJAX CALL ERROR\n The script CSS: "+cssLink1+" is not found - "+xhr.status + " " + xhr.statusText+"\n.");
		
		  }
		  else {
			  $('#w2_form_css').val($('#w2_form_css').text());
			  customedCssImgDir = $('#css_theme').val();
			  $('#customed_css_img_dir').val(customedCssImgDir);
			  $('.'+w2_is_clicked_btn+'').trigger('click');
		  }
		});
    }
	
	
	function initFormEditor2() {
		
		$('.w2_btn_view').bind('click', function() {
			 refreshPreview();	
		});
	
		$('.w2_btn_source').bind('click', function() {
			$('.w2_view_block').fadeOut(500);
			setTimeout( function() {
			   $('.w2_view_block').html('');
			   $('.w2_source_block').fadeIn(500);
			   $('.add_ccs_block').fadeIn(500);
			   
			}, 500);
			w2_is_clicked_btn = 'w2_btn_source';			
		});
	}
	
	function refreshPreview() {
			displayContentPreview();	
			
			$('.w2_source_block').fadeOut(500);
			$('.add_ccs_block').fadeOut(500);
			
			setTimeout( function() {
			   $('.w2_view_block').fadeIn(500);
			   if(!initEditor)
			     scroll_to('#bottom_page');
			}, 500);
			
			setTimeout( function() {
			   initEditor = false;
			}, 1500);
	
			w2_is_clicked_btn = 'w2_btn_view';	
    }
	
	function displayContentPreview() {
		    var sourceContainerForm = '';
			sourceContainerForm = $('.source_code_container_form').text();
			
			var sourceFields = '';
			sourceFields = $('#w2_form_source').val();
			if($('#w2_form_source').val() == '')
			   sourceFields = 'You need to load a HTML template ...';
			
			var pluginUrl = $('.plugin_url_to_js').attr('target');
			var sourceCss = '';
			sourceCss = $('#w2_form_css').val();
			
			if($('#css_theme').val() != 'default') {
			 if($('#custom_template:checked').val() == 1)
			   var imgDir = customedCssImgDir;
			 else
			   var imgDir = $('#css_theme').val();
				
			  var imgUrl = '(w2_acf/css/w2_contact_form/'+imgDir+'/images/';
			}
			else
			  var imgUrl = '('+$('.plugin_url_to_js').attr('currentcss')+'/images/';
			  
			imgUrl = imgUrl.replace('/custom.css', '');
			sourceCss = sourceCss.replace(/\(images\//g, imgUrl);
			var imgUrl2 = '(w2_acf/css/w2_contact_form/images/';
			sourceCss = sourceCss.replace(/\(\.\.\/images\//g, imgUrl2);

			var sourceForm = '';
			sourceForm = sourceContainerForm.replace("[fields_zone]", sourceFields);

			if($('#custom_template:checked').val() == 1)
			  sourceForm = '<style type="text/css">'+sourceCss+'</style>'+sourceForm;
			  
			$('.w2_view_block').html(sourceForm);
			initW2ContactForm();
	}
	
    function scroll_to(scrollto) {
    	  var scroll_to = $(scrollto).offset().top;
    	  $('html, body').animate({ scrollTop: scroll_to+'px' }, 1000);
    }
	


});
