/*
	w2ContactForm - jQuery Ajax Contact Form
 	Copyright (c) 2012 Gui-yem
	
	Version: 1.0 
	Created: 30 OCTOBER 2012
	
	Built using:
	jQuery				   version: 1.7	        http://jquery.com/
	jQuery	UI			   version: 1.8.24  	http://jqueryui.com/
	jQuery Validate        version: 1.9     	http://bassistance.de/jquery-plugins/jquery-plugin-validation/
	jQuery Form            version: 2.63    	http://malsup.com/jquery/form/
	jquery.ui.touch-punch  version: 0.1.0   	http://touchpunch.furf.com/
*/
(function($) {   
	   //plugin
        $.fn.w2ContactForm = function(options, value) {
                var optExtended = $.extend({}, $.fn.w2ContactForm.defaults, options);
				var notificationsExtended = $.extend({}, $.fn.w2ContactForm.notifications);
				var plugin;
				return this.each(function () {		
					//API of the Plugin
					if (typeof options == 'string') {
						if ($(this).data('w2ContactForm')) {
							plugin = $.fn.w2ContactForm.interfaces[$(this).data('id')];
							switch(options) {
								default:
								  //No API for this Plugin
								break;
							}
						}
					}
					else
					{
						 //new Plugin instance
						 var id = $.fn.w2ContactForm.interfaces.length;
						 $(this).data('w2ContactForm', true);
						 $(this).data('id', id);
						 plugin = new w2ContactForm ($(this), optExtended, notificationsExtended);
						 //save instance in array of instances
						 $.fn.w2ContactForm.interfaces[id] = plugin;
					 }
				});
        }
		$.fn.w2ContactForm.interfaces = [];
		//Default Configuration
		$.fn.w2ContactForm.defaults = {
			noSpamControl: true,  //Specifie if No Spam Control is activate (true / false)
			noSpamControlType: 1,  //Spcifie the Type of No Spam Control (1 / 2)
			resetForm: true, //Spcifie if reset form after submit (true / false)
			reCaptchaPublicKey: null, //Specifie your reCaptcha PublicKey
			reCaptchaId: 'recaptcha', //Specifie an unqiue ID for HTML element where reCaptcha will be integrated (just specifie the ID do not create the element in the form)
			reCaptchaTheme: 'clean', //Specifie the reCaptcha theme you want to use
			reCaptchaLang: 'en', //Specifie the reCaptcha Lang you want to use
			reloadCaptcha: true, //Specifie if captcha is reloaded after submit (true / false)
			ayah: false, //Specifie if AYAH is activate
			attachmentFile: true,  //Specifie if attachment file is activate (true / false)
			maxAttachments: 5, //Specifie the maximum number of attachments files
			showBtnSend: false, //Specifie if the btn send is visible when loading form when No Spam Control is activate (true / false)
			customFileInput: true, //Specifie if file input is custom skin (true / false)
			uiWidget: true, //Specifie if you want to use UI widget (datepicker, buttonset) (true / false)
			submitAlertType: 'slide', //Specifie the type of alert displaying for submit (dialog / slide)
			maxAttAlertType: 'slide', //Specifie the type of alert displaying for maximum attachments (dialog / slide)
			urlLoaderImg: 'w2_acf/css/w2_contact_form/images/ajax-loader.gif', //Specifie the url of the loader image
			nospamInfoHover: true, //Specifie if nospam infos is displaying on mouseover (true / false)
			shapesFolder: 'w2_acf/css/w2_contact_form/images/shapes/',
			progressBar: false,  //Specifies if progress bar is activated
			beforeSubmit: null, //Callback for javascript validation
			submitSuccess: null //Callback for success submit
		};
		$.fn.w2ContactForm.notifications = {
			addAtt: 'Add attachment',
			maxAtt: 'The maximum number of attachment is ',
			inputFile: 'Choose a file',
			nspmc4: 'Choose the right shape and<br />Drop the left square on the right square',
			nspmc3: 'Choose the right number and<br />Drop the left square on the right square',
			nspmc2: 'Choose the right color and<br />Drop the left square on the right square',
			nspmc1: 'Drop the left square on the right square'
		};
		
		
	    //constructor
	    function w2ContactForm(container, options, notifications) {

			var self = this;
			self.container = container;
			self.options = options;
			self.notifications = notifications;
			self.options.formId = '#'+$('form', self.container).attr('id');
 
			//initialisation
			self.msieDetect();
			self.isTimeOutResponse = false;
			//self.initPlaceholder();
			
			if(self.options.uiWidget)
			  self.initUiWidgets();
			
			if(self.options.ayah)
			  self.initAyahField();
			  
			self.fixCssBug();
			if(self.options.attachmentFile)
			  self.initAttachmentTags();
			
			if(self.options.noSpamControl)
			  self.initNspmcTags();
			  
			if(self.options.progressBar)
			  self.initProgressBarTags();
			  
			self.initLoaderTags();

			if(self.options.reCaptchaPublicKey != null && self.options.reCaptchaId != '')
			  self.initRecaptchaTags();
			
			self.indexAttElt = 0;
			
			var reponseAjaxClass = self.options.formId+'response';
			var reponseAjaxClass = reponseAjaxClass.replace("#","")
			$('.responseAjaxContact', self.container).addClass(reponseAjaxClass);
			// bind form using ajaxForm
			var resetForm = self.options.resetForm;
			
			//self.initValidateFormContact
			
			var bar = $('.w2_bar', self.container);
            var percent = $('.w2_percent', self.container);
			
			
			$(self.options.formId).ajaxForm({ 
				// target identifies the element(s) to update with the server response
				beforeSubmit: function(arr, $form, options) { 
					 var isValidate = self.initValidateFormContact();
					 return isValidate;               
				},
				beforeSend: function() {
					if(self.options.progressBar) {
						var percentVal = '0%';
						bar.width(percentVal)
						percent.html(percentVal);
					}
				},
				uploadProgress: function(event, position, total, percentComplete) {
					if(self.options.progressBar) {
						var percentVal = percentComplete + '%';
						bar.width(percentVal)
						percent.html(percentVal);
					}
				},
				target: '.'+reponseAjaxClass,
				resetForm: resetForm,
				// success identifies the function to invoke when the server response 
				// has been received; here we apply a slideToggle effect to the content ajax response
				success: function() {
					if(self.options.progressBar) {
					  bar.width('100%');
					  var percentVal = '100%';
					  percent.html(percentVal);
					  var timer = setTimeout(function(){
						self.initFormContact ();
						if($('.recaptcha', self.container).length > 0)
						  self.initReCaptcha();
					  },1000);
					}
					else {
						self.initFormContact ();
						if($('.recaptcha', self.container).length > 0)
						  self.initReCaptcha();
					}
					
					
				},
				error: function() {
					alert('AJAX CALL ERROR');
				} 
			});
			
			if(self.options.customFileInput)
			  self.createCustomFileInput();
			
			if($('.btn_add_attachment', self.container).length > 0)
			  self.initAddAttachment();
			
			if($('.draggable_nspmc', self.container).length > 0)
			  self.initDragDropNspmc();
			
			if($('.draggable_2_nspmc', self.container).length > 0)
			  self.initDragDropNspmc2();
			
			if($('.draggable_3_nspmc', self.container).length > 0)
			  self.initDragDropNspmc3();
			  
			if($('.draggable_4_nspmc', self.container).length > 0)
			  self.initDragDropNspmc4();
			
			if($('.container_drag_drop_nspmc', self.container).length == 0 || self.options.showBtnSend)
			   $('.btn_send', self.container).css('display', 'block');

			 self.initTimeField();				
		};
        
		
		w2ContactForm.prototype.msieDetect = function () {
				var self = this;
				
				self.msie = false;
				self.ieversion = 0;
				if (/MSIE (\d+\.\d+);/.test(navigator.userAgent)){ //test for MSIE x.x;
				  self.msie = true;
				  self.ieversion = new Number(RegExp.$1) // capture x.x portion and store as a number
				  if(self.ieversion < 10)
				    self.initPlaceholder();
				}
		}
		
		w2ContactForm.prototype.initValidateFormContact = function () {
				var self = this;
				isValidFormContact = false; 
                idForm = $('form', self.container).attr('id');
				
				//if there is a specified callback for validation
				if (self.options.beforeSubmit != null)
                   var formContact =  self.options.beforeSubmit(idForm);
				else
				   var formContact = $(self.options.formId).validate();
				
				if($(self.options.formId).length > 0) {
				   isValidFormContact = formContact.form();
				   
				   if(isValidFormContact == true) {
					   $(""+self.options.formId+" .loader").fadeIn(300);
					   $(""+self.options.formId+" .btn_send").fadeOut(500);
					   
					   if(self.options.progressBar) {
						   if(self.msie && self.ieversion < 10) {
							 //nothing 
						   }
						   else {
					         $(""+self.options.formId+" .w2_progress").fadeIn(300);
						   }
					   }
				   }
				   
				   $(''+self.options.formId+' label.error', self.container).css({ opacity: "0", color: "#6C0", paddingLeft: "20px"});
				   $(''+self.options.formId+' label.error', self.container).animate({
						color: "#E17575",
						opacity: 1,
						paddingLeft: '0px'
				   }, 1000 );
				   
				   return isValidFormContact;
				}
		}
		
		w2ContactForm.prototype.initUiWidgets = function () {
			var self = this;
			//for radio or checkbox validation
			$.metadata.setType("attr", "validate");
			
			//Creation of ui-datepicker
			$( ".datepicker", self.container ).datepicker({
				changeMonth: true,
				changeYear: true,
				defaultDate:0,
				yearRange: "1900:2020"
			});
			
			//Creation of ui-radioset
			$( ".radioSet", self.container ).buttonset();
			$( ".checkBoxSet", self.container ).buttonset(); 
		}
		
		w2ContactForm.prototype.initPlaceholder = function () {
			var self = this;
			
			// Input placeholder text fix for IE
			$('[placeholder]').focus(function() {
			  var input = $(this);
			  if (input.val() == input.attr('placeholder')) {
				input.val('');
				input.removeClass('placeholder');
			  }
			}).blur(function() {
			  var input = $(this);
			  if (input.val() == '' || input.val() == input.attr('placeholder')) {
				input.addClass('placeholder');
				input.val(input.attr('placeholder'));
			  }
			}).blur();
			
			// Prevent submission of empty form
			$('[placeholder]').parents('form').submit(function() {
			  $(this).find('[placeholder]').each(function() {
				var input = $(this);
				if (input.val() == input.attr('placeholder')) {
				  input.val('');
				}
			  })
			});
		}
		
		w2ContactForm.prototype.showDialog = function (html, title, height, width) {
			var self = this;
			if( $('.dialog_alert .alert_max_att', self.container).length == 0)
			  $(self.container).append('<div class="dialog_alert" title="'+title+'"></div>');
			  
			$( ".dialog_alert", self.container ).html(html);
			
			$( ".dialog_alert", self.container ).dialog({
				resizable: true,
				height:height,
				width:width,
				modal: true,
				show: "fade",
		        hide: "fade",
				buttons: {
					Ok: function() {
						$( this ).dialog( "close" );
					}
				}
			}); 
		}
		
		w2ContactForm.prototype.initTimeField = function () {
			var self = this;
			var target = $(self.options.formId, self.container).attr('action');
			$('.timeField', self.container).load(''+target+'?getTime=true', function(response, status, xhr){
			  if (status == "error") {
				var message = 'Verify the attribute action of the form. It seems there is an error';
				switch(xhr.status) {
					case 500:
					   message = 'Verify the CHMOD for The script PHP: '+target+'. You must specifie a 644 CHMOD (not 777). Make sure there is no PHP error in the script '+target+'';
					break;
					case 404:
					   message = 'The script PHP: '+target+' is not found - Verify the attribute action of the form. It seems there is an error';
					break;
					default:
					break;
				}
				self.showDialog("Error: "+xhr.status+ " " +xhr.statusText+"<br /> "+message+" ", "AJAX CALL ERROR", 200, 300);
			  }
		    }); 
		}
		
		w2ContactForm.prototype.initAyahField = function () {
			var self = this;
			var target = $(self.options.formId, self.container).attr('action');
			
			$.ajax({
				type: 'POST',
				dataType: 'json',
				url: ''+target+'?getAyah=true',
				success: function(data) {
				//data = jQuery.parseJSON(data);
				$('.container_features', self.container).append('<div class="block_element_form container_ayah">'+data.html+'</div>');
				},
				'error': function(obj,status,error) {
                    var message = '';
					self.showDialog("Error: "+status+ " " +error+"<br /> "+message+" ", "AJAX CALL ERROR", 200, 300);
				}
			});
			
		}
		
		w2ContactForm.prototype.fixCssBug = function () {
			var self = this;
			var is_chrome = /chrome/.test( navigator.userAgent.toLowerCase() );
			if(is_chrome){
				$('select', self.container).css('background-image', 'none');
			}
		}
		
		w2ContactForm.prototype.initAttachmentTags = function () {
			var self = this;
			var notification = $('.container_features', self.container).attr('notification');
			var html = '<div class="container_file_attachment"><div class="alert_str" style="display:none;"></div></div><div class="block_element_form"><div class="container_alert_max_att"></div><div class="attachment_notification">'+notification+'</div><div class="btn_add_attachment shadow"><span>+</span>'+self.notifications.addAtt+'</div></div>';
			$('.container_features', self.container).append(html);
			
			if(self.msie && self.ieversion < 8) {
			  $('.btn_add_attachment', self.container).css('width', '135px');
			  $('.container_alert_max_att', self.container).css('display', 'none');
			}
			
		}
		
		w2ContactForm.prototype.initNspmcTags = function () {
			var self = this;
			switch(self.options.noSpamControlType) {
				case 1:
				  var html = '<div class="block_element_form outter_drag_drop_nspmc"><div class="container_drag_drop_nspmc"><div class="draggable_nspmc"></div><div class="droppable_nspmc"></div><div class="icon_arrow"></div></div><div class="message_drag_drop_nspmc1"><span>'+self.notifications.nspmc1+'</span></div></div><div class="nspmc_loader" style="display:none; margin-top:10px;"><img src="'+self.options.urlLoaderImg+'" /></div>';
				break;
				case 2:
				  var html = '<div class="block_element_form outter_drag_drop_nspmc"><div class="container_drag_drop_nspmc"><div class="draggable_2_nspmc color1"></div><div class="draggable_2_nspmc color2"></div><div class="draggable_2_nspmc color3"></div><div class="draggable_2_nspmc color4"></div><div class="droppable_2_nspmc"></div><div class="icon_arrow"></div></div><div class="message_drag_drop_nspmc2"><span>'+self.notifications.nspmc2+'</span></div></div><div class="nspmc_loader" style="display:none; margin-top:10px;"><img src="'+self.options.urlLoaderImg+'" /></div>';
				break;
				case 3:

				  var html = '<div class="block_element_form outter_drag_drop_nspmc"><div class="container_drag_drop_nspmc"><div class="draggable_3_nspmc text1">1</div><div class="draggable_3_nspmc text2">2</div><div class="draggable_3_nspmc text3">3</div><div class="draggable_3_nspmc text4">4</div><div class="droppable_3_nspmc"></div><div class="icon_arrow"></div></div><div class="message_drag_drop_nspmc3"><span>'+self.notifications.nspmc3+'</span></div></div><div class="nspmc_loader" style="display:none; margin-top:10px;"><img src="'+self.options.urlLoaderImg+'" /></div>';
				break;
				case 4:
				  var html = '<div class="block_element_form outter_drag_drop_nspmc"><div class="container_drag_drop_nspmc"><div class="draggable_4_nspmc shape1"></div><div class="draggable_4_nspmc shape2"></div><div class="draggable_4_nspmc shape3"></div><div class="draggable_4_nspmc shape4"></div><div class="droppable_4_nspmc"></div><div class="icon_arrow"></div></div><div class="message_drag_drop_nspmc4"><span>'+self.notifications.nspmc4+'</span></div></div><div class="nspmc_loader" style="display:none; margin-top:10px;"><img src="'+self.options.urlLoaderImg+'" /></div>';
				break;
			}
			$('.container_features', self.container).append(html);
			
			if(!self.options.attachmentFile)
			  $('.message_drag_drop_nspmc'+self.options.noSpamControlType).css('top', '0px');
			  
			if(self.msie && self.ieversion < 9) {
			  $('.message_drag_drop_nspmc'+self.options.noSpamControlType, self.container).css('opacity', '1');
			  self.nspmcOpacityOut = 1;
			}
			else {
			  $('.message_drag_drop_nspmc'+self.options.noSpamControlType, self.container).css('opacity', '0');
			  self.nspmcOpacityOut = 0;
			}
			
			if(self.options.nospamInfoHover) {
				$('.container_drag_drop_nspmc', self.container).unbind('mouseenter');
				$('.container_drag_drop_nspmc', self.container).bind('mouseenter', function() {
					 $('.message_drag_drop_nspmc'+self.options.noSpamControlType, self.container).stop().animate({
						width: "200px",
						opacity: 1
				     }, 400 );	 		
				});
				
				$('.container_drag_drop_nspmc', self.container).unbind('mouseleave');
				$('.container_drag_drop_nspmc', self.container).bind('mouseleave', function() {
					 $('.message_drag_drop_nspmc'+self.options.noSpamControlType, self.container).stop().animate({
						width: "0px",
						opacity: self.nspmcOpacityOut
				     }, 400 );	 
				});
			}
			else {
				$('.message_drag_drop_nspmc'+self.options.noSpamControlType, self.container).fadeTo(1000, 1);
			}
			
		}
		
		w2ContactForm.prototype.initLoaderTags = function () {
			var self = this;

			var html = '<div class="block_element_form"><div class="loader" style="display:none;"><img src="'+self.options.urlLoaderImg+'" /></div></div>';
			
			$('.container_features', self.container).append(html);
			
		}
		
		w2ContactForm.prototype.initProgressBarTags = function () {
			var self = this;

			var html = '<div class="block_element_form"><div class="w2_progress"><div class="w2_bar"></div><div class="w2_percent"></div></div></div>';
			
			$('.container_features', self.container).append(html);
			
		}	

		w2ContactForm.prototype.initRecaptchaTags = function () {
			var self = this;
			var html = '<div class="block_element_form recaptcha" id="'+self.options.reCaptchaId+'"></div>';
			$('.container_features', self.container).append(html);
			//creation of the reCaptcha element
			Recaptcha.create(self.options.reCaptchaPublicKey, self.options.reCaptchaId, {theme: self.options.reCaptchaTheme, lang: self.options.reCaptchaLang});
			
		}
		
		w2ContactForm.prototype.initNspmc2Fields = function () {
			var self = this;
			if($('.nspmc2', self.container).length > 0)
			   $('.nspmc2', self.container).remove();
			if($('.nspmc', self.container).length > 0)
			   $('.nspmc', self.container).remove();
			var target = $(self.options.formId, self.container).attr('action');
			var nspmcTimeValue = $('.nspmctime', self.container).val();
		
			$('.timeField', self.container).load(''+target+'?getNspmc2='+nspmcTimeValue+'', function(response, status, xhr){
			  if (status == "error") {
				var message = 'Verify the attribute action of the form. It seems there is an error';
				switch(xhr.status) {
					case 500:
					   message = 'Verify the CHMOD for The script PHP: '+target+'. You must specifie a 644 CHMOD (not 777). Make sure there is no PHP error in the script '+target+'';
					break;
					case 404:
					   message = 'The script PHP: '+target+' is not found - Verify the attribute action of the form. It seems there is an error';
					break;
					default:
					break;
				}
				self.showDialog("Error: "+xhr.status+ " " +xhr.statusText+"<br /> "+message+" ", "AJAX CALL ERROR", 200, 300);
			  }
			  else {

				  setTimeout( function() {
				    self.showSendBtn();
				  }, 500);
				  
			  }
		    });   
		}
	
		w2ContactForm.prototype.initReCaptcha = function () {
			var self = this;
			if(self.options.reloadCaptcha)
			  $('#recaptcha_reload', self.container).trigger('click');  
		}
		
		w2ContactForm.prototype.noSpam = function () {
			var self = this;
			self.initNspmc2Fields();
			$(".outter_drag_drop_nspmc", self.container).fadeOut(500);
			$(".nspmc_alert", self.container).fadeOut(500);
			$(".btn_nospam", self.container).fadeOut(500);
			
			setTimeout( function() {
			   $(".nspmc_loader", self.container).fadeIn(200);
			}, 500);

            //self.showSendBtn();
		}
		
		w2ContactForm.prototype.showSendBtn = function () {
			var self = this;
			$(".nspmc_loader", self.container).fadeOut(300);
			setTimeout( function() {
			   $(".btn_send", self.container).fadeIn(500);
			}, 500);
		}
		
		w2ContactForm.prototype.initFormContact = function () {
			    var self = this;
				
				$('.attachment_notification', self.container).css('display', 'none');
				if($('.draggable_nspmc', self.container).length > 0)
				  $(".draggable_nspmc", self.container).css({ left: "0px", top: "0px"});
				$(".outter_drag_drop_nspmc", self.container).fadeIn(500);
				
				//Display messages
				if(self.isTimeOutResponse)
				  clearTimeout(self.timeOutResponse);
				$('.responseAjaxContact', self.container).css("display", "none");
				if(self.options.submitAlertType == 'slide') {
					self.isTimeOutResponse = true;
					$('.responseAjaxContact', self.container).slideToggle(1000);
					
					//callback for success response
					self.submitSuccessCallback();
					
					self.timeOutResponse = setTimeout( function() {
					   $('.responseAjaxContact', self.container).slideToggle(1000);
					}, 10000);
				}
				else {
					var html = $('.responseAjaxContact', self.container).html();
					var nottificationHeight = $('.responseAjaxContact', self.container).height();
					nottificationHeight = 150 + nottificationHeight;
					self.showDialog(html, '', nottificationHeight, 480);
					//callback for success response
					self.submitSuccessCallback();
				}
				
				$(".loader", self.container).css("display", "none");
				
				if(self.options.progressBar) {
				  $(".w2_progress", self.container).css("display", "none");
				}
				
				$(".new_attachment", self.container).remove();
				$('.nspmc2', self.container).val('0');
				setTimeout( function() {
				   $(".btn_nospam", self.container).fadeIn(500);
				}, 3000);
				
				if($('.container_drag_drop_nspmc', self.container).length == 0)
				  $(".btn_send", self.container).fadeIn(500);
				self.initAddAttachment();
				self.initTimeField();
				if($('.draggable_2_nspmc', self.container).length > 0)
				  self.initDragDropNspmc2();
				  
				if(self.options.ayah) {
					$(".container_ayah", self.container).remove();
					self.initAyahField();
				}
				
		}
		
		w2ContactForm.prototype.submitSuccessCallback = function () {
			var self = this;
			//callback for success response
			if(self.options.submitSuccess != null) {
			  if($('.responseAjaxContact .w2_notification-success', self.container).length > 0) {
				  self.options.submitSuccess(self);
			  }
			}
		}
		
		w2ContactForm.prototype.initAddAttachment = function () {
				var self = this;
				var maxFileAttachment = 0;
				if($('.container_file_attachment', self.container).length > 0)
				  maxFileAttachment = self.options.maxAttachments;
				  
				$('.btn_add_attachment', self.container).unbind('click');
				$('.btn_add_attachment', self.container).bind('click', function() {
					var nbAttachment = $('.input_file_attachment', self.container).length;
					if(nbAttachment == 0)
					  $('.attachment_notification', self.container).fadeIn(500);
					var alertStr = self.notifications.maxAtt;
					var alertStr2 = self.notifications.inputFile;
		
					if(nbAttachment < maxFileAttachment) {
						nbAttachment++;
						self.indexAttElt++;
						
						if(self.options.customFileInput) {	
						  $('.container_file_attachment', self.container).append('<div class="new_attachment new_attachment_'+self.indexAttElt+'" style="display:none;"><span target="file_attachment_'+self.indexAttElt+'" class="btn_choose_file btn" ><span class="label_input_cstm">'+alertStr2+'</span><input type="file" name="attachment'+self.indexAttElt+'" class="input_file_attachment file_attachment_'+self.indexAttElt+' custom_file" /></span><span class="btn_delete_att"></span></div>');
						}
						else {
						  $('.container_file_attachment', self.container).append('<div class="new_attachment new_attachment_'+self.indexAttElt+'" style="display:none;"><input type="file" name="attachment'+self.indexAttElt+'" class="input_file_attachment file_attachment_'+self.indexAttElt+' no_custom_file" /><span class="btn_delete_att"></span></div>');
						}
						
						$('.new_attachment_'+self.indexAttElt+'', self.container).slideToggle(700);
						nbAttachment = $('.input_file_attachment', self.container).length;
						self.initBtnDeleteAtt();
						
						if(self.options.customFileInput)
						  self.fileInputChangeHandler();
					}
					else {
						if(self.options.maxAttAlertType == 'dialog')
					      self.showDialog(alertStr+' '+maxFileAttachment+'', '', 180, 300);
					    else
						  self.showAlertMaxAtt(alertStr+' '+maxFileAttachment+'');
					}
				});
		}
		
		w2ContactForm.prototype.createCustomFileInput = function () {
				var self = this;
				var alertStr2 = self.notifications.inputFile;
				var totalCustomField = 0;
				$('input.custom_file', self.container).each(function () {
                    totalCustomField++;
					var name = $(this).attr('name');
					var error ='';
					var id = 'w2_custom_input_'+totalCustomField+'';
					var required = '';
					if($(this).is('.required')) {
						error = '<label for="w2_custom_input_'+totalCustomField+'" class="error label_custom_input" style="display:none;" generated="true"></label>';
						required = 'required';
					}
					$(this).parent().children('.label_text').attr('for', id);
					$(this).parent().append('<div class="clear"></div><div style="overflow:hidden; width:119px;"><span class="btn_choose_file btn" style="float:none; margin-bottom:2px; margin-top:2px; display:block; overflow:visible; "><input id="'+id+'" type="file" name="'+name+'" class="'+required+' input_file_attachment custom_file" /><span class="label_input_cstm">'+alertStr2+'</span></span></div><div class="clear"></div>'+error+'');	
					$(this).remove();
					
			    });
				self.fileInputChangeHandler();
		}
		
		w2ContactForm.prototype.showAlertMaxAtt = function (str) {
			var self = this;
			
			if( $('.container_alert_max_att .alert_max_att', self.container).length > 0)
			  $('.container_alert_max_att .alert_max_att', self.container).remove();

			$('.container_alert_max_att', self.container).append('<div class="w2_notification-error alert_max_att" style="display:none"><span class="icon"></span><span class="w2_notification-message">'+str+'</span></div>');
			
			var $alertMaxAtt =  $('.container_alert_max_att .alert_max_att', self.container);
			
			$alertMaxAtt.slideToggle(500);
			setTimeout( function() {
			   $alertMaxAtt.slideToggle(500);
			}, 3000);		
		}
		
		w2ContactForm.prototype.initBtnDeleteAtt = function () {
			var self = this;
			$('.btn_delete_att', self.container).unbind('click');
			$('.btn_delete_att', self.container).bind('click', function() {
				$(this).parent().fadeOut(500);
				element = $(this);
				setTimeout( function() {
				   self.removeFieldAtt(element);
				}, 500);		
			});
		}
		
		w2ContactForm.prototype.fileInputChangeHandler = function () {
			var self = this;
			$('.custom_file', self.container).unbind('change');
			$('.custom_file', self.container).bind('change', function() {
				var text = $(this).val();
				if($(this).val() == '')
				  text = self.notifications.inputFile;
				else {
				  text = self.getFileInputName(text);
				}
				$(this).parent().children('.label_input_cstm').text(text);		
			});		
		}
		
		w2ContactForm.prototype.getFileInputName = function (value) {
			  valueArray = value.split('\\');
			  var nameFile = valueArray[valueArray.length-1];
			  if(nameFile.length > 10)
			    nameFile = nameFile.substr(0, 9)+' ...';
			  return nameFile;
		}
		
		w2ContactForm.prototype.removeFieldAtt = function (element) {
			var self = this;
			element.parent().remove();
			if($('.input_file_attachment', self.container).length == 0)
			   $('.attachment_notification', self.container).fadeOut(500);
		}
		
		w2ContactForm.prototype.initDragDropNspmc = function () {
			var self = this;		
			$( ".draggable_nspmc", self.container ).draggable({ 
				   revert: "invalid" ,
				   opacity: 0.7,
				   cursor: "move",
				   containment: ""+self.options.formId+" .container_drag_drop_nspmc", scroll: false,
				   start: function() {
		
				   },
				   drag: function() {
						
				   },
				   stop: function() {
		
				   }
			});
			$( ".droppable_nspmc", self.container).droppable({
				hoverClass: "dorppable_hover",
				over: function(event, ui) { 
				   $( ".droppable_nspmc", self.container ).addClass('dropped_nspmc');
				},
				out: function(event, ui) { 
				   $( ".droppable_nspmc", self.container ).removeClass('dropped_nspmc');
				},
				//accept: ".accpetedItem",
				drop: function( event, ui ) {
					$( ".droppable_nspmc", self.container ).removeClass('dropped_nspmc');
					self.releaseDropped();
				}
			});
				
		}
		
		w2ContactForm.prototype.initDragDropNspmc2 = function() {
			var self = this;
			var colorDraggable = Array();
			var j = 0;
			$(".draggable_2_nspmc", self.container).each(function() {
				colorDraggable[j] = $(this).css('background-color');
				j++; 
			});
			
			var randomIndex = Math.floor(Math.random()*4)
			var colorDroppable = colorDraggable[randomIndex];
			$( ".droppable_2_nspmc", self.container).css('background-color', colorDroppable);
			var accpetedItem = randomIndex + 1;
			accpetedItem = ".color"+accpetedItem;
					
			$( ".draggable_2_nspmc", self.container).draggable({ 
				   revert: "invalid" ,
				   opacity: 0.7,
				   cursor: "move",
				   containment: ""+self.options.formId+" .container_drag_drop_nspmc", scroll: false,
				   start: function() {
		
				   },
				   drag: function() {
						
				   },
				   stop: function() {
		
				   }
			});
			$( ".droppable_2_nspmc", self.container).droppable({
				hoverClass: "dorppable_hover",
				over: function(event, ui) { 
				
				},
				out: function(event, ui) { 
				
				},
				accept: accpetedItem,
				drop: function( event, ui ) {
					self.elementDropped = ui.draggable;
					self.elementDropped.addClass('w2_is_dropped');
					self.releaseDropped2('color');
				}
			});
				
		}
		
		w2ContactForm.prototype.initDragDropNspmc3 = function() {
			var self = this;
			var textDraggable = Array();
			var j = 0;
			$(".draggable_3_nspmc", self.container).each(function() {
				textDraggable[j] = $(this).text();
				j++; 
			});
			
			var randomIndex = Math.floor(Math.random()*4)
			var textDroppable = textDraggable[randomIndex];
			$( ".droppable_3_nspmc", self.container).text(textDroppable);
			var accpetedItem = randomIndex + 1;
			accpetedItem = ".text"+accpetedItem;
					
			$( ".draggable_3_nspmc", self.container).draggable({ 
				   revert: "invalid" ,
				   opacity: 0.7,
				   cursor: "move",
				   containment: ""+self.options.formId+" .container_drag_drop_nspmc", scroll: false,
				   start: function() {
		
				   },
				   drag: function() {
						
				   },
				   stop: function() {
		
				   }
			});
			$( ".droppable_3_nspmc", self.container).droppable({
				hoverClass: "dorppable_hover",
				over: function(event, ui) { 
				
				},
				out: function(event, ui) { 
				
				},
				accept: accpetedItem,
				drop: function( event, ui ) {
					self.elementDropped = ui.draggable;
					self.elementDropped.addClass('w2_is_dropped');
					self.releaseDropped2('text');
				}
			});
				
		}
		
		w2ContactForm.prototype.initDragDropNspmc4 = function() {
			var self = this;
			var shapeDraggable = Array();
			var j = 0;
			$(".draggable_4_nspmc", self.container).each(function() {
				shapeDraggable[j] = $(this).css('background-color');
				j++; 
			});
			
			var randomIndex = Math.floor(Math.random()*4)
			var shapeDroppable = shapeDraggable[randomIndex];
			var accpetedItem = randomIndex + 1;
			$( ".droppable_4_nspmc", self.container).css({ backgroundColor: shapeDroppable, backgroundImage: 'url('+self.options.shapesFolder+'shape_'+accpetedItem+'_xl.png)' });
			accpetedItem = ".shape"+accpetedItem;
					
			$( ".draggable_4_nspmc", self.container).draggable({ 
				   revert: "invalid" ,
				   opacity: 0.7,
				   cursor: "move",
				   containment: ""+self.options.formId+" .container_drag_drop_nspmc", scroll: false,
				   start: function() {
		
				   },
				   drag: function() {
						
				   },
				   stop: function() {
		
				   }
			});
			$( ".droppable_4_nspmc", self.container).droppable({
				hoverClass: "dorppable_hover",
				over: function(event, ui) { 
				
				},
				out: function(event, ui) { 
				
				},
				accept: accpetedItem,
				drop: function( event, ui ) {
					self.elementDropped = ui.draggable;
					self.elementDropped.addClass('w2_is_dropped');
					self.releaseDropped2('shape');
				}
			});
				
		}
		
		w2ContactForm.prototype.initDraggablePosition = function (className) {
			   var self = this;
			   $( "."+className+"1", self.container).css({ left: "0px", top: "0px"});
			   $( "."+className+"2", self.container).css({ left: "20px", top: "0px"});
			   $( "."+className+"3", self.container).css({ left: "0px", top: "20px"});
			   $( "."+className+"4", self.container).css({ left: "20px", top: "20px"});
		}
		
		w2ContactForm.prototype.releaseDropped = function () {	
		      var self = this;
			  var left = '101px';
			  //fix css bug for template "inline"
			  if($('table .align_right',self.container ).length > 0)
			     left = '101px';
				 
			  $( ".draggable_nspmc", self.container).animate({
				top: '1px',
				left: left
			  }, 500, function() {	  
				  self.noSpam();
			  });    
		}
		
		w2ContactForm.prototype.releaseDropped2 = function (className) {		
			  var self = this; 
			  //self.noSpam();
			  $('.w2_is_dropped', self.container).animate({
				top: '11px',
				left: '111px'
			  }, 500, function() {	  
				  self.noSpam();
				  setTimeout( function() {
					 self.elementDropped.removeClass('w2_is_dropped');
				     self.initDraggablePosition(className)
			      }, 800);
			  }); 	  
		}

})(jQuery);