<?php
/*
	w2ContactForm - Ajax Contact Form
 	Copyright (c) 2012 Gui-yem
	
	Version: 1.8 
	Created: 9 OCTOBER 2012
	
	Built using:
	Zend Framework     version  1.11     http://framework.zend.com/		
*/


//Begin reCaptcha integration//////////////////////////////////////////
require_once('recaptchalib.php');
//Specifie your private key for recaptcha
$privatekey = "********************************";

$isValidCaptcha = false;
if(isset($_POST["recaptcha_response_field"])) {
  $resp = recaptcha_check_answer ($privatekey,
								$_SERVER["REMOTE_ADDR"],
								$_POST["recaptcha_challenge_field"],
								$_POST["recaptcha_response_field"]);

  if (!$resp->is_valid) {
	$isValidCaptcha = false;
  } else {
	$isValidCaptcha = true;
  }
}
define('IS_VALID_CAPTCHA', $isValidCaptcha);
//End reCaptcha integration////////////////////////////////////////////





//Begin AYAH integration//////////////////////////////////////////
// Instantiate the AYAH object.
require_once("ayah/ayah.php");
$ayah = new AYAH();

// If the PlayThru does not work correctly, enable debug mode.
//$ayah->debug_mode(TRUE);

$isValidAYAH = false;
// The form submits to itself, so see if the user has submitted the form.
if (array_key_exists('nspmctime', $_POST))
{
	// Use the AYAH object to get the score.
	$score = $ayah->scoreResult();
	// Check the score to determine what to do.
	if ($score)
		$isValidAYAH = true;
	else
		$isValidAYAH = false;
}
define('IS_VALID_AYAH', $isValidAYAH);
//End AYAH integration////////////////////////////////////////////





//set $autoLoadZend = true to load Zend Componoents with autoloader 
$autoLoadZend = false;
if(!$autoLoadZend) {
   //Put Zend folder to the root of of web site folder or directly in the include_path.
   require_once 'Zend/Mail.php';
   require_once 'Zend/Translate.php';
}
else {
//Load Zend Componoents with autoloader (usefull to place the Zend folder in the folder that you want in this example: /lib/Zend/)
	set_include_path(
		implode(PATH_SEPARATOR, array(
			get_include_path(),
			realpath(dirname(__FILE__).'/lib')
		)));
	require_once realpath(dirname(__FILE__).'/lib/Zend/Loader/Autoloader.php');
	$autoloader = Zend_Loader_Autoloader::getInstance();
}






class W2ContactForm
{
	/***************************
    *                          *
    *        Properties        *
    *                          *
    ***************************/
	//Specifie a encryption key for no spam control (only alphanumeric - not special character - max: 30 characters).
	private $key_encrypt = 'pokie52_235mp_oej_2537fdfgh';
	protected $mailSender;
	protected $mail_recipient;
	protected $autoResponder;
	protected $mailResponder;
	protected $site_name;
	protected $requiredFields;
	protected $bodyMessageFields;
	protected $mailSubject;
	protected $htmlFields;
	protected $acceptHtmlContent;
	protected $utf_8_encode;
	protected $uploadsFolder;
	protected $max_file_size;
	protected $maxAttachmentFiles;
	protected $extFile_ok;
	protected $deleteUploadsAfterSending;
	protected $antiSpamTimeControl;
	protected $autoCHMOD;
	protected $noSpamControl;
	protected $reCaptcha;
	protected $ayah;
	protected $pathToTranslation;
	public $lang;
	public $notificationText;
	public $mimes;
	private $smtpHost;
	private $smtpHostConfig;
	protected $responderAtt;
	protected $sendAsAttachment;
	
    public function __construct()
    {
	   /***************************
	   *                          *
	   *   Default Configuration  *
	   *                          *
	   ***************************/
	   
	   //Specifies the emails sender. If you don't specifie email sender the email used to send the mail will be the user mail (who submit the form)
	   $this->mailSender = '';
	   //Specifies the emails recipients. You can specifies several emails for multiple recipient. If only one email is specifie the default email will be the first (index 1)
	   $this->mail_recipient = array('1' => 'youremail@me.net', '2' => 'youremail2@me.net');
	   //Specifies if you want to use auto responder feature
	   $this->autoResponder = false;
	   //Specifies if you want to use an email different that email sender to the auto responder
	   $this->mailResponder = '';
	   //Specifies the name of your web site
	   $this->site_name = 'mysite';
	   //Specifies the required fields for the form validation. 
	   $this->requiredFields = array('recipient', 'mail', 'subject', 'message');
	   //Specifies the fields for adding them in the mail body message (exammple:  array('mail' => 'E-mail', 'message' => 'Message')) - if you don't specifie field all the fields will be automatically added to the mail body message
	   $this->bodyMessageFields = '';
	   //Specifies the subject of the email if you don't use subject field in your form
	   $this->mailSubject = 'subject of the message';
	   //Specifies the fields need HTML encodage (example: textarea)
	   $this->htmlFields = array('message');
	   //Specifies if HTML tags is accepted in the email message (for the textarea form element)
	   $this->acceptHtmlContent = false;
	   //Specifies if the HTML form is encoded in utf_8
	   $this->utf_8_encode = true;
	   //Specifies the folder for uploads attachments files in your server
	   $this->uploadsFolder = dirname(__FILE__).'/uploads';
	   //Specifies the max file size for the attachments files (in octet)
	   $this->max_file_size = 1000000;
	   //Specifies the maximum number for attachments files
	   $this->maxAttachmentFiles = 5;
	   //Specifies the accepted extensions (.jpg, .png, .pdf ...) for the attachments files
	   $this->extFile_ok = array('pdf', 'doc', 'docx', 'jpeg', 'jpg', 'png', 'gif');
	   //Specifies if you want to delete files uploaded after email sending
	   $this->deleteUploadsAfterSending = true;
	   //Specifies the minimum and maximum time between submission of the form (in seconds)
	   $this->antiSpamTimeControl = array('min' => '5', 'max' => '3600');
	   //Specifies if you want the script configure the CHMOD for "uploads" folder
	   $this->autoCHMOD = false;
	   //Specifies if you want to use no spam control (drag and drop)
	   $this->noSpamControl = true;
	   //Specifies if you want to use recaptcha for validation form
	   $this->reCaptcha = false;
	   //Specifies if you want to use AYAH for validation form
	   $this->ayah = false;
	   //Specifies the language for notifications text (en, es, fr, de)
	   $this->lang = 'en';
	   //Specifies if you want to send mail via smtp. You must specify your smtp host.
	   $this->smtpHost = '';
	   //Specifies the config for your smtp host.
	   $this->smtpHostConfig = array();
	   //Specifies the path to the traslation file.
	   $this->pathToTranslation = 'languages/w2_cf_notifications.tmx';
	   //Specifies the path to the responder attachments.
	   $this->responderAtt = array();
	   //Specifies if you want to send uploaded files as attachment.
	   $this->sendAsAttachment = true;   
	   
	   
	   //specifies the date_default_timezone_set for your script. It depends of your country. For more informations look at the php manual						 
	   date_default_timezone_set('America/New_York');
	   
	   //specifies the MIMES type available for attachments files
	   $this->mimes = array(
					  'hqx'   =>  'application/mac-binhex40',
					  'cpt'   =>  'application/mac-compactpro',
					  'doc'   =>  'application/msword',
					  'docx'  =>  'application/msword',
					  'bin'   =>  'application/macbinary',
					  'dms'   =>  'application/octet-stream',
					  'lha'   =>  'application/octet-stream',
					  'lzh'   =>  'application/octet-stream',
					  'exe'   =>  'application/octet-stream',
					  'class' =>  'application/octet-stream',
					  'psd'   =>  'application/octet-stream',
					  'so'    =>  'application/octet-stream',
					  'sea'   =>  'application/octet-stream',
					  'dll'   =>  'application/octet-stream',
					  'oda'   =>  'application/oda',
					  'pdf'   =>  'application/pdf',
					  'ai'    =>  'application/postscript',
					  'eps'   =>  'application/postscript',
					  'ps'    =>  'application/postscript',
					  'smi'   =>  'application/smil',
					  'smil'  =>  'application/smil',
					  'mif'   =>  'application/vnd.mif',
					  'xls'   =>  'application/vnd.ms-excel',
					  'ppt'   =>  'application/vnd.ms-powerpoint',
					  'wbxml' =>  'application/vnd.wap.wbxml',
					  'wmlc'  =>  'application/vnd.wap.wmlc',
					  'dcr'   =>  'application/x-director',
					  'dir'   =>  'application/x-director',
					  'dxr'   =>  'application/x-director',
					  'dvi'   =>  'application/x-dvi',
					  'gtar'  =>  'application/x-gtar',
					  'php'   =>  'application/x-httpd-php',
					  'php4'  =>  'application/x-httpd-php',
					  'php3'  =>  'application/x-httpd-php',
					  'phtml' =>  'application/x-httpd-php',
					  'phps'  =>  'application/x-httpd-php-source',
					  'js'    =>  'application/x-javascript',
					  'swf'   =>  'application/x-shockwave-flash',
					  'sit'   =>  'application/x-stuffit',
					  'tar'   =>  'application/x-tar',
					  'tgz'   =>  'application/x-tar',
					  'xhtml' =>  'application/xhtml+xml',
					  'xht'   =>  'application/xhtml+xml',
					  'zip'   =>  'application/zip',
					  'rar'   =>  'application/x-rar-compressed',
					  'mid'   =>  'audio/midi',
					  'midi'  =>  'audio/midi',
					  'mpga'  =>  'audio/mpeg',
					  'mp2'   =>  'audio/mpeg',
					  'mp3'   =>  'audio/mpeg',
					  'aif'   =>  'audio/x-aiff',
					  'aiff'  =>  'audio/x-aiff',
					  'aifc'  =>  'audio/x-aiff',
					  'ram'   =>  'audio/x-pn-realaudio',
					  'rm'    =>  'audio/x-pn-realaudio',
					  'rpm'   =>  'audio/x-pn-realaudio-plugin',
					  'ra'    =>  'audio/x-realaudio',
					  'rv'    =>  'video/vnd.rn-realvideo',
					  'wav'   =>  'audio/x-wav',
					  'bmp'   =>  'image/bmp',
					  'gif'   =>  'image/gif',
					  'jpeg'  =>  'image/jpeg',
					  'jpg'   =>  'image/jpeg',
					  'jpe'   =>  'image/jpeg',
					  'png'   =>  'image/png',
					  'tiff'  =>  'image/tiff',
					  'tif'   =>  'image/tiff',
					  'css'   =>  'text/css',
					  'html'  =>  'text/html',
					  'htm'   =>  'text/html',
					  'shtml' =>  'text/html',
					  'txt'   =>  'text/plain',
					  'text'  =>  'text/plain',
					  'log'   =>  'text/plain',
					  'rtx'   =>  'text/richtext',
					  'rtf'   =>  'text/rtf',
					  'xml'   =>  'text/xml',
					  'xsl'   =>  'text/xml',
					  'mpeg'  =>  'video/mpeg',
					  'mpg'   =>  'video/mpeg',
					  'mpe'   =>  'video/mpeg',
					  'qt'    =>  'video/quicktime',
					  'mov'   =>  'video/quicktime',
					  'avi'   =>  'video/x-msvideo',
					  'movie' =>  'video/x-sgi-movie',
					  'mp4'   =>  'video/mp4',
                      'flv'   =>  'video/x-flv',
					  'doc'   =>  'application/msword',
					  'word'  =>  'application/msword',
					  'xl'    =>  'application/excel',
					  'eml'   =>  'message/rfc822'
					);
    }
	
	public function setMailSender($value)
    {
		$this->mailSender = $value;	
	}
	
	public function setMailRecipient($value)
    {
		$this->mail_recipient = $value;	
	}
	
	public function setAutoResponder($value)
    {
		$this->autoResponder = $value;	
	}
	
	public function setMailResponder($value)
    {
		$this->mailResponder = $value;	
	}
	
	public function setSiteName($value)
    {
		$this->site_name = $value;	
	}
	
	public function setRequiredFields($value)
    {
		$this->requiredFields = $value;	
	}
	
	public function setBodyMessageFields($value)
    {
		$this->bodyMessageFields = $value;	
	}
	
	public function setMailSubject($value)
    {
		$this->mailSubject = $value;	
	}

	public function setHtmlFields($value)
    {
		$this->htmlFields = $value;	
	}
	
	public function setAcceptHtmlContent($value)
    {
		$this->acceptHtmlContent = $value;	
	}
	
	public function setUtf8Encode($value)
    {
		$this->utf_8_encode = $value;	
	}
	
	public function setUploadsFolder($value)
    {
		$this->uploadsFolder = $value;	
	}
	
	public function setMaxFileSize($value)
    {
		$this->max_file_size = $value;	
	}
	
	public function setMaxAttachmentFiles($value)
    {
		$this->maxAttachmentFiles = $value;	
	}
	
	public function setExtFileOk($value)
    {
		$this->extFile_ok = $value;	
	}
	
	public function setDeleteUploadsAfterSending($value)
    {
		$this->deleteUploadsAfterSending = $value;	
	}

	public function setAntiSpamTimeControl($value)
    {
		$this->antiSpamTimeControl = $value;	
	}
	
	public function setAutoCHMOD($value)
    {
		$this->autoCHMOD = $value;	
	}
	
	public function setNoSpamControl($value)
    {
		$this->noSpamControl = $value;	
	}
	
	public function setReCaptcha($value)
    {
		$this->reCaptcha = $value;	
	}
	
	public function setAyah($value)
    {
		$this->ayah = $value;	
	}
	
	public function setLang($value)
    {
		$this->lang = $value;	
	}
	
	public function setResponderAtt($value)
    {
		$this->responderAtt = $value;	
	}
	
	public function setSendAsAttachment($value)
    {
		$this->sendAsAttachment = $value;	
	}
	
	public function setSmtpHost($value, $config = array())
    {
		$this->smtpHost = $value;
		$this->smtpHostConfig = $config;	
	}
	public function setPathToTranslation($value)
    {
		$this->pathToTranslation = $value;
	}
	
	public function setDefaultTimeZone($value)
    {
		date_default_timezone_set($value);
	}

	public function setNotificationTextByLang()
    { 	   
        $this->notificationText = new Zend_Translate('tmx',
													 $this->pathToTranslation,
													 'en');
		if (!$this->notificationText->isAvailable($this->lang)) {
			$this->lang = 'en';
		}
		$this->notificationText->setLocale($this->lang);
	}
	//AJAX
    public function getTimeField()
    {
		echo '<input type="hidden" name="nspmctime" value="'.time().'" class="nspmctime" />';			
	}
	//AJAX
	public function getNspmc2Field($time) {
		echo '<input type="hidden" name="nspmctime" value="'.$time.'" class="nspmctime" />';
		 
		$nspmc2 = $this->randomString(10).'-'.$time;
		echo '<input type="hidden" name="nspmc2" value="'.$nspmc2.'" class="nspmc2" />';
		
		$nspmc = $this->encrypt($nspmc2);
		echo '<input type="hidden" name="nspmc" value="'.$nspmc.'" class="nspmc" />';
	}
	//AJAX
    public function getAyahField()
    {
		$ayah = new AYAH();
		$data["html"] = $ayah->getPublisherHTML();
        print json_encode($data);	
	}
	
	public function randomString($nbCar) {
		
		$string = "";
		$letters = "abcdefghijklmnpqrstuvwxy";
		srand((double)microtime()*1000000);
		
		for($i=0; $i<$nbCar; $i++) {
		  $string .= $letters[rand()%strlen($letters)];
		}
	    return $string;
	}

	private function get_rnd_iv($iv_len) {
		$iv = '';
		while ($iv_len-- > 0) {
		  $iv .= chr(mt_rand() & 0xff);
		}
        return $iv;
    }
     
    public function encrypt($plain_text, $iv_len = 16) {
		$plain_text .= "\x13";
		$n = strlen($plain_text);
		if ($n % 16) {
		    $plain_text .= str_repeat("\0", 16 - ($n % 16));
			$i = 0;
			$enc_text = $this->get_rnd_iv($iv_len);
			$iv = substr($this->key_encrypt ^ $enc_text, 0, 512);
			while ($i < $n) {
			  $block = substr($plain_text, $i, 16) ^ pack('H*', sha1($iv));
			  $enc_text .= $block;
			  $iv = substr($block . $iv, 0, 512) ^ $this->key_encrypt;
			  $i += 16;
			}
			return base64_encode($enc_text);
        } 
		else {}
    }
     
    public function decrypt($encrypt_text, $iv_len = 16) {
		$encrypt_text = base64_decode($encrypt_text);
		$n = strlen($encrypt_text);
		$i = $iv_len;
		$plain_text = '';
		$iv = substr($this->key_encrypt ^ substr($encrypt_text, 0, $iv_len), 0, 512);
		while ($i < $n) {
			$block = substr($encrypt_text, $i, 16);
			$plain_text .= $block ^ pack('H*', sha1($iv));
			$iv = substr($block . $iv, 0, 512) ^ $this->key_encrypt;
			$i += 16;
		}
		return stripslashes(preg_replace('/\\x13\\x00*$/', '', $plain_text));
	}
		
	public function sendEmail()
    {
        $this->setNotificationTextByLang();
		
		$isValidForm = true;
		$incomplete = false;
		
		//if using recaptcha
		$captchaNotification = '';
		if($this->reCaptcha) {
		  $isValidForm = IS_VALID_CAPTCHA;
		  if(!$isValidForm)
		    $captchaNotification = $this->notificationText->_('recaptchaerror');
		}
		
		//if using ayah
		$ayahNotification = '';
		if($this->ayah) {
		  $isValidForm = IS_VALID_AYAH;
		  if(!$isValidForm)
		    $captchaNotification = $this->notificationText->_('ayaherror');
		}
        
		//validation of requireds fields
	    $valuesPost = $this->validForm($_POST, $this->requiredFields, $this->htmlFields);
	    if(!is_array($valuesPost)) {
		   $isValidForm = false;
		   $valuesPost['notification'] = $this->notificationText->_('incomplete');
		}
		else {
			
			if(array_key_exists('mail', $this->requiredFields)) {
				if(!$this->validEmail($valuesPost['mail'])) {
				  $isValidForm = false;
				  $valuesPost['notification'] = $this->notificationText->_('badmail');
				}
			}
			
			//Validation of no spam control
			if($this->noSpamControl) {
				
				$valuesNspmc = $this->validForm($_POST, array('nspmctime', 'nspmc', 'nspmc2'));
				if(is_array($valuesNspmc)) {
					$isValidTimeNspmc = false;
					$time = explode('-', $valuesNspmc['nspmc2']);
					$nb = count($time);
		            $time = strtolower($time[$nb-1]);
		
					if($this->decrypt($valuesNspmc['nspmc']) != $valuesNspmc['nspmc2'] || time() < ($valuesNspmc['nspmctime'] + $this->antiSpamTimeControl['min']) || $time != $valuesNspmc['nspmctime'] || ($valuesNspmc['nspmctime'] + $this->antiSpamTimeControl['max'] < time())) {
					  $isValidForm = false;
					  $valuesPost['notification'] = $this->notificationText->_('nspmcerror');
					}
				}
				else {
					$isValidForm = false;
					$valuesPost['notification'] = $this->notificationText->_('nspmcerror');
				}
			}
		}
  
		$attachments = array();
		//Verify the configuration for uploads folder (if the folder uploads exists and has the right CHMOD)
		if(count($_FILES) > 0) {
			$folderExists = true;
			$isValidCHMOD = true;
			if(is_dir($this->uploadsFolder)) {
			   if($this->autoCHMOD)
			       $isValidCHMOD = chmod($this->uploadsFolder, 0700);
			   else {
				   $CHMOD_folder = substr(sprintf('%o', fileperms($this->uploadsFolder)), -4);
				   if(intval($CHMOD_folder) < 700)
					  $isValidCHMOD = false;
			   }
			}
			else
			   $folderExists = false;
		}
		
		foreach ($_FILES as $key => $value) {
            if(count($_FILES) <= $this->maxAttachmentFiles) {
				if($folderExists && $isValidCHMOD) {
					$name_index = $key;
					$nbAtt = 0;
					if($_FILES[$name_index]['tmp_name'] != "") {
					  $nbAtt++;
					  if($nbAtt <= $this->maxAttachmentFiles) {
						  $file = array_merge($_FILES);
						  $values = $this->uploadFile ($this->extFile_ok, $this->uploadsFolder.'/', $file, $name_index, $this->max_file_size, "100000", "100000");	  
						  $url_file = $values['url_img'];
						  
						  if($values['notification'] != "")
							$isValidForm = false;
						  else
							$attachments[] = $url_file;
					  }
					  
					}
				}
				else {
					$isValidForm = false;
					$values = array('notification' => $this->notificationText->_('nofolder'));
				}
			}
			else {
			   $isValidForm = false;
			   $values['notification'] = $this->notificationText->_('tooattachment') ;
			}
		}
		
		
		if($isValidForm) {
			
			$mail = new Zend_Mail('UTF-8');

			if($this->smtpHost != '') {
			  //For SMTP sending
			  require_once 'Zend/Mail/Transport/Smtp.php';
			  $tr = new Zend_Mail_Transport_Smtp($this->smtpHost, $this->smtpHostConfig);
              Zend_Mail::setDefaultTransport($tr);
			}

			if(count($attachments) > 0) {
				foreach ($attachments as $value) {
					$name_file = explode("/", $value);
					$name_file = $name_file[count($name_file)-1];
					$extension_file = $this->get_extension($name_file);
					$name_file_no_extension = str_replace($extension_file, '', $name_file);

					$type = $this->mimes[$extension_file];
                    
					if($this->sendAsAttachment) {
						$mail->createAttachment(file_get_contents($value),
										  $type,
										  Zend_Mime::DISPOSITION_INLINE,
										  Zend_Mime::ENCODING_BASE64,
										  $name_file_no_extension.$extension_file);
					}
				}
			}
			
			if($this->mailSender == "") {
			  if(isset($valuesPost['mail']) && $valuesPost['mail'] != '')
			    $mail->setFrom($valuesPost['mail'], $valuesPost['mail']);
			  else
			    $mail->setFrom('no-reply@mywebsite.net', 'no-reply@mywebsite.net');
			}
			else
			  $mail->setFrom($this->mailSender, $this->site_name);
			
			if(isset($valuesPost['recipient'])) {
				if(is_array($valuesPost['recipient'])) {
						foreach ($valuesPost['recipient'] as $recipient_index) {
							if(array_key_exists($recipient_index, $this->mail_recipient)) {
							   $recipient = $this->mail_recipient[$recipient_index];
							   $mail->addTo($recipient, $recipient);
							}
							else {
								$recipient = $this->mail_recipient[1];
				                $mail->addTo($recipient, $recipient);	
							}
						}
				}
				else {
					if(array_key_exists($valuesPost['recipient'], $this->mail_recipient)) {
					   $recipient = $this->mail_recipient[$valuesPost['recipient']];
					   $mail->addTo($recipient, $recipient);
					}
					else {
						$recipient = $this->mail_recipient[1];
						$mail->addTo($recipient, $recipient);
					}
				}
			}
			else {
				$recipient = $this->mail_recipient[1];
				$mail->addTo($recipient, $recipient);
			}

			$subject = $this->mailSubject;
			if(isset($valuesPost['subject']) && $valuesPost['subject'] != '')
			  $subject = $valuesPost['subject'];
			$mail->setSubject($subject);

			$this->mailMessage = "";
			$valuesPost = $this->unsetUnuseFields($valuesPost);  
			$this->getFieldsToMessage ($valuesPost, $this->bodyMessageFields );
			$mail->setBodyHtml($this->mailMessage);

			try {
				   $mail->send();
			} 
			catch ( Exception $e ) {
				echo "Error sending Email : ";
				echo $e->getMessage() . "\n\n\n";
				return false;
			}
			
			//delete the uploaded files after mail send
			if($this->deleteUploadsAfterSending) {
				if(count($attachments) > 0) {						  
					foreach ($attachments as $url_fil_to_delete) {
						if(file_exists($url_fil_to_delete))
						  @unlink($url_fil_to_delete);
					}
				}
			}
			
			//Auto reponder
			if($this->autoResponder && isset($valuesPost['mail'])) {
			   $mailResponder = new Zend_Mail('UTF-8');
			   $mailResponder->setSubject($this->notificationText->_('autorespondersubject'));
			   $this->setAcceptHtmlContent(true);

			   $values = $this->getFieldsToMessage ($valuesPost, $this->notificationText->_('autorespondermessage'));

			   if($values)
			     $this->mailResponderMessage = $this->mailMessage;
			   else
			     $this->mailResponderMessage = $this->notificationText->_('autorespondermessage');
			   
			   $mailResponder->setBodyHtml($this->mailResponderMessage);
			   
			   if($this->mailResponder == '' && $this->mailSender == "")
			     $this->mailResponder = 'no-reply@mysite.net';
			   else if ($this->mailResponder == '')
			     $this->mailResponder = $this->mailSender;
				 
			   $mailResponder->setFrom($this->mailResponder, $this->site_name);
			   $mailResponder->addTo($valuesPost['mail'], $valuesPost['mail']);
			   
			   if(!is_dir(dirname(__FILE__).'/uploads/responder/')) {
				  mkdir(dirname(__FILE__).'/uploads/responder/');
				  chmod(dirname(__FILE__).'/uploads/responder/', 0755);
			   }

			   if(count($this->responderAtt) > 0) {
					foreach ($this->responderAtt as $value) {
						$value = $this->uploadsFolder.'/responder/'.$value;
						$name_file = explode("/", $value);
						$name_file = $name_file[count($name_file)-1];
						$extension_file = $this->get_extension($name_file);
						$name_file_no_extension = str_replace($extension_file, '', $name_file);
	
						$type = $this->mimes[$extension_file];
	
						$mailResponder->createAttachment(file_get_contents($value),
										  $type,
										  Zend_Mime::DISPOSITION_INLINE,
										  Zend_Mime::ENCODING_BASE64,
										  $name_file_no_extension.$extension_file);
	
					}
				}
			   
			    try {
				   $mailResponder->send();
				} 
				catch ( Exception $e ) {
				    echo "Error sending Email : ";
					echo $e->getMessage() . "\n\n\n";
					return false;
				}
			   
			}
			
			//notification success
			echo '<div class="w2_notification-success"><span class="icon"></span><span class="w2_notification-message">'.$this->notificationText->_('sent').'</span></div>';

        }
		else {
			$postNotifications = '';
			if(isset($valuesPost['notification']))
			  $postNotifications = $valuesPost['notification'].'<br />';
			$uploadNotifications = '';  
			if(isset($values['notification']))
			  $uploadNotifications = $values['notification'].'<br />';
			echo '<div class="w2_notification-error"><span class="icon"></span><span class="w2_notification-message">'.$this->notificationText->_('notsent').'<br />'.$postNotifications.$uploadNotifications.$captchaNotification.$ayahNotification.'</span></div>';
			
		}
		
		//return true if mail sending and false if not sending
		return $isValidForm;
	}
	
	public function validEmail($value){
	  return mb_eregi("^[_a-z0-9-]+(.[_a-z0-9-]+)*@[a-z0-9-]+(.[a-z0-9-]+)*(.[a-z]{2,4})$", $value);
	}
	
	public function validForm ($valuesPost, $required, $escapeHtml = array()){
          
		  $validForm = true;
		  $values = array();
		  
		  $postKeys = array_keys($valuesPost);
		  foreach ($required as $value) {
			  if(!in_array($value, $postKeys))
				$validForm = false;
		  }

		  if($validForm) {
			  foreach ($valuesPost as $key => $value) {
				  if(in_array($key, $required) && $value == "")
					$validForm = false;
				  
				  if (in_array($key, $escapeHtml))
					$values[$key] = $this->escapeMail($this->escapeInHTML ($value));
				  else {
					if(!is_array($value))
					  $values[$key] = $this->escapeIn ($value);
					else
					  $values[$key] = $value;
				  }
			  }
		  }
		  
		  if($validForm)
		     return $values;
		  else
		     return false;
	}
	
	public function unsetUnuseFields($valuesPost) {
		if(isset($valuesPost['nspmctime']))
		  unset($valuesPost['nspmctime']);
		if(isset($valuesPost['nspmc']))
		  unset($valuesPost['nspmc']);
		if(isset($valuesPost['nspmc2']))
		  unset($valuesPost['nspmc2']);
		if(isset($valuesPost['recaptcha_challenge_field']))
		  unset($valuesPost['recaptcha_challenge_field']);  
		if(isset($valuesPost['recaptcha_response_field']))
		  unset($valuesPost['recaptcha_response_field']);  
		if(isset($valuesPost['form_id']))
		  unset($valuesPost['form_id']);
		if(isset($valuesPost['recipient']))
		  unset($valuesPost['recipient']);
		
		return $valuesPost;
	}
	
	public function getFieldsToMessage ($valuesPost, $fields){
		  $customMessage = false;
		  //custom (fields are specified)
		  if($fields != '') {
			  
			  if (preg_match_all("#\[(.+)\]#U", $fields, $fieldTags, PREG_PATTERN_ORDER)) {  
				 $customMessage = true; 
                 $nameFields = array();
				 $valuesFieldsTotal = array();
				 $strToReplaces = array();
				 
				 foreach($fieldTags[0] as $tag) {
					$strToReplaces[] = $tag;
				 }
				 foreach($fieldTags[1] as $nameField) {
					
					if(isset($valuesPost[$nameField]) && $valuesPost[$nameField] != '') {
					   if(is_array($valuesPost[$nameField])) {
						   $valuesField = '';
						   foreach ($valuesPost[$nameField] as $valueField) {
							   $valuesField .= $valueField.", ";
						   }
						   $valuesFieldsTotal[] = $valuesField;
					   }
					   else
						 $valuesFieldsTotal[] = $valuesPost[$nameField];
					}
					else
					  $valuesFieldsTotal[] = '';
				 }
			     $this->mailMessage = str_replace($strToReplaces, $valuesFieldsTotal, $fields);  
			  }    
		  }
		  //default (no field are specified)
		  else {
			  foreach ($valuesPost as $key => $value) {
					if(isset($valuesPost[$key]) && $valuesPost[$key] != '') {
					   //include the value of the new field in the message
					   if(is_array($valuesPost[$key])) {
						   $valuesField = '';
						   foreach ($valuesPost[$key] as $valueField) {
							   $valuesField .= $valueField.", ";
						   }
						   $this->mailMessage .= "<p>".$key.": ".$valuesField."<br /></p>";
					   }
					   else
						 $this->mailMessage .= "<p>".$key.": ".$value."<br /></p>";
					}  
			  }
		  }
		  
		  return $customMessage;
	}
	
	public function uploadFile ($extensions_ok, $dest_dossier, $files, $name_index, $taille_max, $largeur, $hauteur) 
	{ 

				$notification="";

				if ($files[$name_index]['tmp_name'] == "")
				{
				  $errors[] = $this->notificationText->_('noimage');
				}
				else 
				{
				  $hasError = false;
				  switch ($files[$name_index]['error']) {
					case 1:
						$errors[] = $this->notificationText->_('filetoobig')." $taille_ko Ko";
						$hasError = true;
						break;
					case 2:
						$errors[] = $this->notificationText->_('filetoobig')." $taille_ko Ko";
						$hasError = true;
						break;
					case 3:
						$errors[] = $this->notificationText->_('unfinishedupload');
						$hasError = true;
						break;
					case 4:
						$errors[] = $this->notificationText->_('nofileupload');
						$hasError = true;
						break;
					case 6:
						$errors[] = $this->notificationText->_('notemp');
						$hasError = true;
						break;
					case 7:
						$errors[] = $this->notificationText->_('unwhrited');
						$hasError = true;
						break;
				}
	 
				$taille_ko = $taille_max / 1000;

				$isImage = false;
				switch($this->get_extension($files[$name_index]['name']))
				{
				  case 'jpg':
				  case 'jpeg':
				  case 'png':
				  case 'gif':
					 $isImage = true;
				  break;
				}
				
				//if the file is a image
				if($isImage) {
					if(!$getimagesize = getimagesize($files[$name_index]['tmp_name'])) 
					{
					  $hasError = true;
					  $errors[] = "".$files[$name_index]['name']." ".$this->notificationText->_('unvalidimg');
					}
					//Verify dimensions of image
					if( $getimagesize[0] > $largeur)
					{
					   $errors[] = $this->notificationText->_('widthtoo');
					   $hasError = true;
					}
					if( $getimagesize[1] > $hauteur)
					{
					   $errors[] = $this->notificationText->_('heighttoo');
					   $hasError = true;
					}
				}
				
				if( (!in_array( $this->get_extension($files[$name_index]['name']), $extensions_ok )))
				{
				  $errors[] = $this->notificationText->_('badtype');
				  $hasError = true;
				}

				//Verify the file size
				if( file_exists($files[$name_index]['tmp_name']) and filesize($files[$name_index]['tmp_name']) > $taille_max)
				{
				  $errors[] = $this->notificationText->_('filetoobig')." $taille_ko Ko !";
				  $hasError = true;
				}

				$dest_fichier = basename($files[$name_index]['name']);
				$dest_fichier = strtr($dest_fichier, 'ABCDEFGHIJKLMNOPQRSTUVWXYZÀÁÂÃÄÅÇÈÉÊËÌÍÎÏÒÓÔÕÖÙÚÛÜÝàáâãäåçèéêëìíîïðòóôõöùúûüýÿ', 'abcdefghijklmnopqrstuvwxyzaaaaaaceeeeiiiiooooouuuuyaaaaaaceeeeiiiioooooouuuuyy');
				// regex to replace what is not integer or letter by "_"
				$dest_fichier = preg_replace('/([^.a-z0-9]+)/i', '_', $dest_fichier);
				// if the file exists
				while(file_exists($dest_dossier . $dest_fichier)) 
				{
					$dest_fichier = rand().$dest_fichier;
				} 
				
				if(!$hasError && move_uploaded_file($files[$name_index]['tmp_name'], $dest_dossier . $dest_fichier)) 
					$valid[] = "";
				else 
				{
					//$errors[] = "";
					$hasError = true;
				} 
				if (isset($errors[0]))  
				{
				  for($i=0;$i<sizeof($errors);$i++)
				  { 
					$notification.= $errors[$i]." <br /> "; 
				  }  
				}
				if (isset($valid[0]))  
				{
					for($i=0;$i<sizeof($valid);$i++)
					{
					  $valid[$i] =($valid[$i]);
					} 
				} 
				  
				  $returnValues = array();
				  $returnValues['notification'] = $notification;
				  
				  if (!$hasError)
					 $returnValues['url_img'] = $dest_dossier . $dest_fichier ;
				  else 
					 $returnValues['url_img'] = ""; 
					 
					 
				  return $returnValues;				 
				}
    }
	
	public function get_extension($nom) {
		$nom = explode(".", $nom);
		$nb = count($nom);
		return strtolower($nom[$nb-1]);
	}
	
	public function escapeSubject ($str)
	{
		if($this->utf_8_encode)
		  $str = utf8_decode($str);
		$str = str_replace("&quot;", "\"", $str);
		return $str; 
	}
	
	public function escapeIn ($str)
	{
		$str = trim ($str);
		$str = htmlspecialchars($str);
		return $str; 
	}
	
	public function escapeInHTML ($str)
	{
		$str = trim ($str);
		if($this->utf_8_encode)
		  $str = utf8_encode($str);
		if(!$this->acceptHtmlContent)
		  $str = htmlspecialchars($str);
		$str = nl2br($str);
		return $str; 
	}
	
	public function escapeMail ($str)
	{
		$str = trim ($str);
		if($this->utf_8_encode)
		  $str = utf8_decode($str);
		return $str;
	}
}


/***************************
*                          *
*           AJAX           *
*                          *
***************************/

//AJAX CALL (do not remove)
if(isset($_GET['getTime'])) {
  //creation of a new instance of Class Contact
  $contact = new W2ContactForm();
  $contact->getTimeField();
}
//AJAX CALL (do not remove)
else if(isset($_GET['getNspmc2'])) {
  //creation of a new instance of Class Contact
  $contact = new W2ContactForm();
  $contact->getNspmc2Field($_GET['getNspmc2']);
}
//AJAX CALL (do not remove)
else if(isset($_GET['getAyah'])) {
  //creation of a new instance of Class Contact
  $contact = new W2ContactForm();
  $contact->getAyahField();
}

?>